#include "box.h"

Box::Box(int ID, char* name, int tesselation) : Primitive(ID, name, tesselation)
{

}

Box::~Box(){

}

void Box::drawPrimitive(){
    //tesselation
    double qubeWidth = 1.0;
    double dist = qubeWidth / (double)tesselation;



    //4.1.1 Unit Qube + Tesselation + Diffuse Material


    GLfloat specularColor[] = { 1, 1, 1 };
    GLfloat shininess[] = { 128 };//specular exponent
    glMaterialfv(GL_FRONT, GL_SPECULAR, specularColor);
    glMaterialfv(GL_FRONT, GL_SHININESS, shininess);

    //vorne // z-Achse
    //    glColor3f(0,0,1);//blau //alt und doof
    GLfloat blue[] = { 0, 0, 1 };
    glMaterialfv(GL_FRONT, GL_DIFFUSE, blue);
    glNormal3f(0, 0, 1);
    glBegin(GL_QUADS);
    for (int i = 0; i < tesselation; i++){
        for (int j = 0; j < tesselation; j++){
            glVertex3f(0.5 - dist*i, 0.5 - dist*j, 0.5);
            glVertex3f(0.5 - dist*(i + 1), 0.5 - dist*j, 0.5);
            glVertex3f(0.5 - dist*(i + 1), 0.5 - dist*(j + 1), 0.5);
            glVertex3f(0.5 - dist*i, 0.5 - dist*(j + 1), 0.5);
        }
    }
    glEnd();

    //oben // y-Achse
    GLfloat green[] = { 0, 1, 0 };
    glMaterialfv(GL_FRONT, GL_DIFFUSE, green);
    glNormal3f(0, 1, 0);
    glBegin(GL_QUADS);
    for (int i = 0; i < tesselation; i++){
        for (int j = 0; j < tesselation; j++){
            glVertex3f(0.5 - dist*(i + 1), 0.5, 0.5 - dist*(j + 1));
            glVertex3f(0.5 - dist*(i + 1), 0.5, 0.5 - dist*j);
            glVertex3f(0.5 - dist*i, 0.5, 0.5 - dist*j);
            glVertex3f(0.5 - dist*i, 0.5, 0.5 - dist*(j + 1));
        }
    }
    glEnd();

    //rechts //x-Achse
    GLfloat red[] = { 1, 0, 0 };
    glMaterialfv(GL_FRONT, GL_DIFFUSE, red);
    glNormal3f(1, 0, 0);
    glBegin(GL_QUADS);
    for (int i = 0; i < tesselation; i++){
        for (int j = 0; j < tesselation; j++){
            glVertex3f(0.5, 0.5 - dist*i, 0.5 - dist*j);
            glVertex3f(0.5, 0.5 - dist*(i + 1), 0.5 - dist*j);
            glVertex3f(0.5, 0.5 - dist*(i + 1), 0.5 - dist*(j + 1));
            glVertex3f(0.5, 0.5 - dist*i, 0.5 - dist*(j + 1));
        }
    }
    glEnd();

    //hinten // z-Achse
    GLfloat yellow[] = { 1, 0.9f, 0 };
    glMaterialfv(GL_FRONT, GL_DIFFUSE, yellow);
    glNormal3f(0, 0, -1);
    glBegin(GL_QUADS);
    for (int i = 0; i < tesselation; i++){
        for (int j = 0; j < tesselation; j++){
            glVertex3f(0.5 - dist*i, 0.5 - dist*(j + 1), -0.5);//4
            glVertex3f(0.5 - dist*(i + 1), 0.5 - dist*(j + 1), -0.5);//3
            glVertex3f(0.5 - dist*(i + 1), 0.5 - dist*j, -0.5);//2
            glVertex3f(0.5 - dist*i, 0.5 - dist*j, -0.5);//1
        }
    }
    glEnd();

    //links
    GLfloat cyan[] = { 0, 1, 1 };
    glMaterialfv(GL_FRONT, GL_DIFFUSE, cyan);
    glNormal3f(-1, 0, 0);
    glBegin(GL_QUADS);
    for (int i = 0; i < tesselation; i++){
        for (int j = 0; j < tesselation; j++){
            glVertex3f(-0.5, 0.5 - dist*i, 0.5 - dist*(j + 1));
            glVertex3f(-0.5, 0.5 - dist*(i + 1), 0.5 - dist*(j + 1));
            glVertex3f(-0.5, 0.5 - dist*(i + 1), 0.5 - dist*j);
            glVertex3f(-0.5, 0.5 - dist*i, 0.5 - dist*j);
        }
    }
    glEnd();

    //unten //-y
    GLfloat magenta[] = { 1, 0, 1 };
    glMaterialfv(GL_FRONT, GL_DIFFUSE, magenta);
    glNormal3f(0, -1, 0);
    glBegin(GL_QUADS);
    for (int i = 0; i < tesselation; i++){
        for (int j = 0; j < tesselation; j++){
            glVertex3f(0.5 - dist*i, -0.5, 0.5 - dist*(j + 1));
            glVertex3f(0.5 - dist*i, -0.5, 0.5 - dist*j);
            glVertex3f(0.5 - dist*(i + 1), -0.5, 0.5 - dist*j);
            glVertex3f(0.5 - dist*(i + 1), -0.5, 0.5 - dist*(j + 1));
        }
    }
    glEnd();
}
