#include "rigidbodytransformation.h"

RigidBodyTransformation::RigidBodyTransformation(Primitive child)
{
    tx = 0;
    ty = 0;
    tz = 0;
    rotation = QQuaternion();
    this->child = child;
}

void RigidBodyTransformation::setTranslation(double x, double y, double z){
    tx = x;
    ty = y;
    tz = z;
}

QQuaternion RigidBodyTransformation::getRotation(){
    return rotation;
}

void RigidBodyTransformation::setRotation(QQuaternion newRotation){
    rotation = newRotation;
}

void RigidBodyTransformation::drawChild(){
    //should be easily extendable to drawChildren

    //set up transform
    //for cube rotation
    QMatrix4x4 m = QMatrix4x4();
    m.rotate(rotation);

    //for cube translation
    QMatrix4x4 translateRot1 = QMatrix4x4(1,0,0,tx,0,1,0,ty,0,0,1,tz,0,0,0,1);

    //stack matrices
    glMultMatrixf(translateRot1.data());//Punkte zurück schieben damit rotation um qube zentrum ist
    glMultMatrixf(m.data());


    //maybe a foreach later on?
    child.drawPrimitive();
}
